import java.util.*;

public class TaskI {

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int n = sc.nextInt();
		if (n == 3) {
			System.out.println("1 2 3");
			return;
		}
		Triplet t;
		Triplet[] with1 = new Triplet[3];
		ArrayList<Triplet> triplets = new ArrayList<>();
		for (int j = 0, i = 0; j < n; j++) {
			t = new Triplet(sc.nextInt(), sc.nextInt(), sc.nextInt());
			if (t.contains(1))
				with1[i++] = t;
			triplets.add(t);
		}

		int[] res = new int[n];
		res[0] = 1;
		res[1] = find(with1);
		res[2] = find(with1, triplets, res[1]);
		triplets.remove(new Triplet(res[0], res[1], res[2]));
		Triplet tr;
		for (int i = 3; i < n; i++) {
			for (int j = 0; j < triplets.size(); j++) {
				tr = triplets.get(j);
				if (tr.contains(res[i - 1], res[i - 2])) {
					res[i] = tr.sum() - res[i - 1] - res[i - 2];
					triplets.remove(tr);
					break;
				}
			}
		}
		for (int i : res) {
			System.out.print(i + " ");
		}
		System.out.println();
	}

	private static int find(Triplet[] with1, ArrayList<Triplet> triplets, int i) {
		int var1, var2;
		if (with1[0].contains(i) && with1[1].contains(i)) {
			var1 = with1[0].sum() - 1 - i;
			var2 = with1[1].sum() - 1 - i;
		} else if (with1[0].contains(i) && with1[2].contains(i)) {
			var1 = with1[0].sum() - 1 - i;
			var2 = with1[2].sum() - 1 - i;
		} else { // if(with1[2].contains(i) && with1[1].contains(i)) {
			var1 = with1[2].sum() - 1 - i;
			var2 = with1[1].sum() - 1 - i;
		}
		for (Triplet t : triplets) {
			if (t.contains(i, var1) && !t.contains(1))
				return var1;
		}
		for (Triplet t : triplets) {
			if (t.contains(i, var2) && !t.contains(1))
				return var2;
		}
		return 0;
	}

	private static int find(Triplet[] with1) {
		HashSet<Integer> set = new HashSet<>();
		set.add(with1[0].a);
		set.add(with1[0].b);
		set.add(with1[0].c);
		set.add(with1[1].a);
		set.add(with1[1].b);
		set.add(with1[1].c);
		set.add(with1[2].a);
		set.add(with1[2].b);
		set.add(with1[2].c);
		set.remove(1);
		for (Integer i : set) {
			if ((with1[0].contains(i) && with1[1].contains(i)) || (with1[0].contains(i) && with1[2].contains(i))
					|| (with1[1].contains(i) && with1[2].contains(i)))
				return i;
		}
		return 0;
	}

	private static class Triplet {
		public final int a, b, c;

		public Triplet(int a, int b, int c) {
			this.a = a;
			this.b = b;
			this.c = c;
		}

		public boolean contains(int i) {
			return a == i || b == i || c == i;
		}

		public boolean contains(int i, int j) {
			if (i != j)
				return contains(i) && contains(j);
			return (a == i && b == i) || (a == i && c == i) || (b == i || c == i);
		}

		@Override
		public String toString() {
			return "T[" + a + ", " + b + ", " + c + "]";
		}

		private int sum() {
			return a + b + c;
		}

		private int min() {
			return Math.min(Math.min(a, b), c);
		}

		private int max() {
			return Math.max(Math.max(a, b), c);
		}

		@Override
		public boolean equals(Object obj) {
			if (this == obj)
				return true;
			if (obj == null)
				return false;
			if (getClass() != obj.getClass())
				return false;
			Triplet other = (Triplet) obj;
			if (min() != other.min())
				return false;
			if (max() != other.max())
				return false;
			if (sum() - min() - max() != other.sum() - other.min() - other.max())
				return false;
			return true;
		}
	}
}
