#include <iostream>
#include <string>

#define ll long long

using namespace std;

const int maxn = 1e3;

void init() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int main() {
    init();
    ll a, b, c;
    cin >> a >> b >> c;
    ll l = 1, r = 1e9;
    ll sum = a + b + c;
    while (l != r){
        ll m = (l + r) >> 1;
        ll x;
        if (sum % 2 == 0) x = 2 * m; else x = 2 * m - 1;
        if (max(a, max(b, c)) > x){
            l = m + 1;
            continue;
        }
        ll d1 = x - a, d2 = x - b, d3 = x - c;
        ll D1 = max(d1, max(d2, d3));
        ll D3 = min(d1, min(d2, d3));
        ll D2 = d1 + d2 + d3 - D1 - D3;
        if (D1 <= D2 + D3) r = m; else l = m + 1;
    }
    ll x = 2 * l - (sum % 2 == 1);
    cout << (3 * x - a - b - c) / 2 << '\n';
    return 0;
}