#include <iostream>
#include <string>
#include <bits/stdc++.h>

#define pb push_back

using namespace std;

const int maxn = 2e5 + 100;

void init() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

map<int, int> foo[maxn];
vector<int> nei[maxn];
bool used[maxn];

int main() {
    init();
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        c--;
        foo[a][b]++;
        foo[a][c]++;
        foo[b][c]++;
        foo[b][a]++;
        foo[c][a]++;
        foo[c][b]++;
    }
    for (int i = 0; i< n; i++){
        for (auto ev: foo[i])
            if (ev.second >= 2)
                nei[i].pb(ev.first);
    }

//    for (int i = 0; i < n; i++) {
//        for (auto ev: nei[i])
//            cout << ev << " ";
//        cout << "\n";
//    }

    used[0] = true;
    used[nei[0][0]] = true;
    int last = nei[0][0];
    cout << 1 << " " << nei[0][0] + 1 << " ";
    for (int i = 2; i< n; i++){
        int cur;
        if (used[nei[last][0]])
            cur = nei[last][1];
        else
            cur = nei[last][0];
        cout << cur + 1 << " ";
        used[cur] = true;
        last = cur;
    }
    return 0;
}


