#include <bits/stdc++.h>
#define all(a) (a).begin(), (a).end()
#define rep(i, n) for (int i = 0; i < (n); i++) 
 
using namespace std;
 
typedef long long ll;
 
const int N = 100001;
int ans[N];
vector<int> li[N];
vector<pair<int, int>> q[N];
int p[N], sz[N];
 
void add(int u, int v) {
    u = p[u];
    v = p[v];
    if (u == v)
        return;
    if (q[u].size() + li[u].size() < q[v].size() + li[v].size())
        swap(u, v);
    for (auto &pp : q[v]) {
        if (p[pp.second] == v)
            continue;
        if (p[pp.second] == u) {
            ans[pp.first]++;
            ans[pp.second]++;
        }
        else {
            q[u].push_back(pp);
        }
    }
    for (int i : li[v]) {
        p[i] = u;
        li[u].push_back(i);
    }
}
 
void link(int u, int v) {
    if (p[u] == p[v]) {
        ans[u]++;
        ans[v]++;
        return;
    }
    q[p[u]].push_back({u, v});
    q[p[v]].push_back({v, u});
}
 
int main() {
#ifdef ONPC
    freopen("a.in", "r", stdin);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0);
    int n, m, k, l, r, u, v;
    cin >> n >> m >> k;
    char c;
    for (int i = 1; i <= n; i++) {
        p[i] = i;
        li[i].push_back(i);
    }
    rep(i, m) {
        cin >> u >> v;
        link(u, v);
    }
    rep(i, k) {
        cin >> u >> v;
        add(u, v);
    }
    int q;
    cin >> q;
    rep(i, q) {
        cin >> c >> u;
        if (c == 'T') {
            cin >> v;
            add(u, v);
        }
        else if (c == 'F') {
            cin >> v;
            link(u, v);
        }
        else
            cout << ans[u] << '\n';
    }
}
