#include <iostream>
#include <string>
#include <vector>
using namespace std;
typedef long long ll;
#define debug(x) cout << (#x) << " = " << (x) << endl;

int main() {
    int n;
    cin >> n;
    string correct_test;
    cin >> correct_test;
    int m;
    cin >> m;
    string tests[m];
    for (auto & test : tests) {
        cin >> test;
    }
    vector<pair<int,int>> matches;
    for (int i = 0; i < m; ++i) {
        for (int j = i + 1; j < m; ++j) {
            int correct1 = 0, correct2 = 0;
            int correct_matches = 0, wrong_matches = 0;
            for (int t = 0; t < n; ++t) {
                bool _1 = tests[j][t] == correct_test[t];
                bool _2 = tests[i][t] == correct_test[t];
                correct1 += _1;
                correct2 += _2;
                correct_matches += _1 && _2;
                wrong_matches += !_1 && !_2;
            }
            if (
                    (correct_matches > correct1 / 2 && wrong_matches > (n - correct1) / 2) &&
                    (correct_matches > correct2 / 2 && wrong_matches > (n - correct2) / 2)
                    ) {
                matches.push_back(make_pair(i + 1, j + 1));
            }
        }
    }
    cout << matches.size() << endl;
    for (auto i : matches) {
        cout << i.first << ' ' << i.second << endl;
    }
}