#include <iostream>
#include <bitset>
#include <vector>

using namespace std;

signed main() {
    int n, m;
    cin >> n >> m;
    bitset<40000007> bs(0);
    vector<int> a;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        x %= m;
        a.push_back(x);
    }
    int res_mod = -1;
    int mask1 = -1;
    for (int mask = 0; mask < (1 << n); ++mask) {
        int cur = 0;
        int tmp = mask;
        for (int i = 0; i < n; ++i) {
            if (tmp & 1) {
                cur += a[i];
                cur %= m;
            }
            tmp >>= 1;
        }
        if (bs[cur]) {
            res_mod = cur;
            mask1 = mask;
            break;
        }
        bs[cur] = 1;
    }

    int mask2 = -1;
    for (int mask = 0; mask < (1 << n); ++mask) {
        int cur = 0;
        int tmp = mask;
        for (int i = 0; i < n; ++i) {
            if (tmp & 1) {
                cur += a[i];
                cur %= m;
            }
            tmp >>= 1;
        }
        if (cur == res_mod) {
            mask2 = mask;
            break;
        }
    }
    vector<int> res1;
    for (int i = 0; i < n; ++i) {
        if (mask1 & 1) {
            res1.push_back(i + 1);
        }
        mask1 >>= 1;
    }

    vector<int> res2;
    for (int i = 0; i < n; ++i) {
        if (mask2 & 1) {
            res2.push_back(i + 1);
        }
        mask2 >>= 1;
    }

    cout << res1.size() << '\n';
    for (auto e : res1) {
        cout << e << " ";
    }
    cout << '\n';
    cout << res2.size() << '\n';
    for (auto e : res2) {
        cout << e << " ";
    }
    cout << '\n';
}
