#include <iostream>
#include <algorithm>
#include <vector>
#include <utility>
using namespace std;

vector<int> b;

bool check(int x, int need, vector<int> &ans)
{
    vector<int> r = b;

    if (x != -1)
    {
        r.erase(find(r.begin(), r.end(), x));
        r.erase(find(r.begin(), r.end(), x));
    }

    if (r.size() == 0)
        return true;

    int sum1 = 0, sum2 = 0;

    for (int i = 0; i < (1 << r.size()); i++)
    {
        ans.clear();

        for (int j = 0; j < r.size(); j++)
        {
            int cur = (i >> j) & 1;

            if (cur == 1)
                ans.push_back(cur);

            if (cur == 1)
                sum1 += b[j];
            else
                sum2 += b[j];

            if (sum1 <= need && sum2 <= need)
                return true;
        }
    }

    return false;
}

int main()
{
    int n, index_big, sum = 0;
    bool is_big = false;

    cin >> n;

    vector<int> a(n);
    vector<int> get;

    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        b.push_back(a[i]);

        if (a[i] >= 180)
        {
            is_big = true;
            index_big = i;
        }

        sum += a[i];
    }

    if (is_big)
    {
        cout << (sum == 360 ? n : n + 1) << "\n";

        int angle = a[index_big];

        cout << "0 0\n";
        cout << angle << " 0\n";

        for (int i = 0; i < n; i++)
            if (i != index_big)
            {
                angle += a[i];

                if (angle != 360)
                    cout << angle << " 0\n";
            }

        return 0;
    }

    vector<int> two;

    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            if (i != j && a[i] == a[j] && a[i] != -1 && a[j] != -1)
            {
                two.push_back(a[i]);
                a[i] = a[j] = -1;
            }

    bool ok = true;
    int angle = 0, need = 180;

    vector<pair<int, int>> ty;

    for (int i = 0; i < two.size(); i++)
    {
        need -= two[i];

        if (check(two[i], need, get))
        {
            b.erase(find(b.begin(), b.end(), two[i]));
            b.erase(find(b.begin(), b.end(), two[i]));

            if (ok)
            {
                ty.push_back({ 0, 1 });
                ok = false;
            }

            angle += two[i];

            if (angle != 180)
                ty.push_back({ angle, 1 });
        }
        else
            need += two[i];
    }

    check(-1, need, get);

    for (int i = 0; i < get.size(); i++)
    {
        ty.push_back({angle + a[get[i]], 0});
        b[get[i]] = -1;
    }

    for (int i = 0; i < b.size(); i++)
        if (b[i] != -1)
            ty.push_back({ angle + b[get[i]] + 180, 0 });

    cout << ty.size() << "\n";

    for (auto each : ty)
        cout << each.first << " " << each.second << "\n";

    return 0;
}