#include <bits/stdc++.h>
#include <String>
using namespace std;
typedef long long ll;

struct Tri{
    int a[3];
    bool consists(int x){return a[0] == x || a[1] == x || a[2] == x;}
};

istream &operator >> (istream &is, Tri &t){
    is >> t.a[0] >> t.a[1] >> t.a[2];
    for (int i = 0; i < 3; ++i)--t.a[i];
    sort(t.a, t.a + 3);
    return is;
}

vector<int> rep(vector<Tri>&p, int i, int j, int k){
    multiset<int> numbers;
    numbers.insert(p[i].a[0]);
    numbers.insert(p[i].a[1]);
    numbers.insert(p[i].a[2]);
    numbers.insert(p[j].a[0]);
    numbers.insert(p[j].a[1]);
    numbers.insert(p[j].a[2]);
    numbers.insert(p[k].a[0]);
    numbers.insert(p[k].a[1]);
    numbers.insert(p[k].a[2]);
    numbers.erase(1);
    vector<int>  ans;
    for(auto it = numbers.begin();it != numbers.end(); ++it){
        auto x = numbers.equal_range(*it);
        if (++x.first != x.second) ans.push_back(*it);
    }
    return vector<int>({ans[0], ans[2]});
}


int main(){
    ll n;
    cin >> n;
    vector<Tri>p(n);
    for (int i = 0; i < n; ++i) cin >> p[i];
    if (n == 3){
        cout << "1 2 3\n";
        return 0;
    }
    vector<vector<int>> ind(n);
    for (int i = 0; i < n; ++i) {
        for (int j : p[i].a) ind[j].push_back(i);
    }
    vector<int> ans(3);
    ans.reserve(n);
    ans[0] = 1;
    int val = 1;
    int i = ind[val][0], j = ind[val][1], k = ind[val][2];
    auto reps = rep(p, i, j, k);
    ans[1] = reps[0];
    if (p[i].consists(reps[0]) && !p[i].consists(reps[1])){
        ans[2] = p[i].a[0] + p[i].a[1] + p[i].a[2] - reps[0] - 1;
    }
    if (p[j].consists(reps[0]) && !p[j].consists(reps[1])){
        ans[2] = p[j].a[0] + p[j].a[1] + p[j].a[2] - reps[0] - 1;
    }
    if (p[k].consists(reps[0]) && !p[k].consists(reps[1])){
        ans[2] = p[k].a[0] + p[k].a[1] + p[k].a[2] - reps[0] - 1;
    }
    while (ans.size() < n - 1){
        val = ans[ans.size() - 1];
        int prev = ans[ans.size() - 2];
        int prevprev = ans[ans.size() - 3];
        int i = ind[val][0], j = ind[val][1], k = ind[val][2];
        if (p[i].consists(prev) && !p[i].consists(prevprev)){
            ans.push_back(p[i].a[0] + p[i].a[1] + p[i].a[2] - prev - val);
        }
        if (p[j].consists(prev) && !p[j].consists(prevprev)){
            ans.push_back(p[j].a[0] + p[j].a[1] + p[j].a[2] - prev - val);
        }
        if (p[k].consists(prev) && !p[k].consists(prevprev)){
            ans.push_back(p[k].a[0] + p[k].a[1] + p[k].a[2] - prev - val);
        }
    }
    ll sum = 0;
    for (int an : ans) {
        cout << an + 1 << " ";
        sum += an;
    }
    cout << n * (n - 1) / 2 - sum + 1;
    return 0;
}
 