// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")
 
#include <bits/stdc++.h>
 
#define debug(x) std::cerr << (#x) << ":\t" << (x) << std::endl;
#define fastIO std::ios_base::sync_with_stdio(false);std::cin.tie(0);std::cout.tie(0);
#define NAME "Problem Name"
 
typedef long long ll;
typedef long double ld;
 
std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
 
const double PI = atan2(0., -1.);
const int INF = 0x3f3f3f3f;
const int N = 50;
 
int a[N], x[N];
 
int main(void) {
    // #ifdef ONLINE_JUDGE
    //  freopen(NAME".in", "r", stdin);
    //  freopen(NAME".out", "w", stdout);
    // #endif
 
    int n;
    scanf("%d", &n);
 
    for (int i = 0; i < n; ++i) {
        scanf("%d", &a[i]);
    }
 
    int cur = 1;
    for (int i = 0; i < n; ++i) {
        if (a[i] == 0) {
            x[i] = cur;
            cur *= 2;
        }
    }
 
    for (int i = 0; i < n; ++i) {
        if (a[i] == -1) {
            x[i] = -cur;
            cur *= 2;
        } else if (a[i] == 1) {
            x[i] = cur;
            cur *= 2;
        }
    }
 
    int m = 0;
    for (int i = 0; i < n; ++i) {
        m += a[i] * x[i];
    }
 
    printf("%d\n", m);
    for (int i = 0; i < n; ++i) {
        printf("%d ", x[i]);
    }
    printf("\n");
 
    return 0;
}