#include <iostream>
#include <vector>
#define int long long

using namespace std;

int x, y, z, a, b, c, t1, t2, t3, d, k, i, l, j;
const long long INF = 4e18;
long long res = INF;
int f1, f2;

void rec(int pos1, int pos2, int cur = 0, int dp = 0) {
    if (dp == 4) return;
    if (cur >= INF) return;
    if (pos1 == 1) {
        rec(2, b + 1, cur + abs(a - pos2) * t1 + d, dp + 1);
        rec(3, c, cur + abs(a + 1 - pos2) * t1 + d, dp + 1);
        if (pos1 == f1) res = min(res, cur + abs(f2 - pos2) * t1);
    }
    if (pos1 == 2) {
        rec(3, c + 1, cur + abs(b - pos2) * t2 + d, dp + 1);
        rec(1, a, cur + abs(b + 1 - pos2) * t2 + d, dp + 1);
        if (pos1 == f1) res = min(res, cur + abs(f2 - pos2) * t2);
    }
    if (pos1 == 3) {
        rec(2, b, cur + abs(c + 1 - pos2) * t3 + d, dp + 1);
        rec(1, a + 1, cur + abs(c - pos2) * t3 + d, dp + 1);
        if (pos1 == f1) res = min(res, cur + abs(f2 - pos2) * t3);
    }
}

void relax(int pos1, int pos2, vector <pair <int, int>> &kek) {
    if (pos1 == 1 && pos2 == a) kek.push_back({2, b + 1});
    if (pos1 == 1 && pos2 == a + 1) kek.push_back({3, c});
    if (pos1 == 2 && pos2 == b) kek.push_back({3, c + 1});
    if (pos1 == 2 && pos2 == b + 1) kek.push_back({1, a});
    if (pos1 == 3 && pos2 == c) kek.push_back({1, a + 1});
    if (pos1 == 3 && pos2 == c + 1) kek.push_back({2, b});
}

signed main() {
    //freopen("input.txt", "r", stdin);
    cin >> x >> y >> z;
    cin >> a >> b >> c;
    cin >> t1 >> t2 >> t3 >> d;
    cin >> k >> i >> l >> j;
    vector <pair <int, int>> st, fin;
    st.push_back({k, i});
    relax(k, i, st);
    fin.push_back({l, j});
    relax(l, j, fin);
    for (auto elem : st) {
        for (auto elem2 : fin) {
            f1 = elem2.first;
            f2 = elem2.second;
            rec(elem.first, elem.second);
        }
    }
    cout << res << endl;
    return 0;
}

