#include <iostream>
#include <vector>

using namespace std;

const int MAX_N = 4e7 + 7;
int summ[MAX_N];
int to_mask[MAX_N];

void qt(int n, int mask1, int mask2) {
    int intersec = mask1 & mask2;
    mask1 -= intersec;
    mask2 -= intersec;
    vector <int> a, b;
    for (int i = 0; i < n; i++) {
        if (mask1 & (1 << i)) a.push_back(i + 1);
        if (mask2 & (1 << i)) b.push_back(i + 1);
    }
    cout << a.size() << endl;
    for (int elem : a) cout << elem << ' ';
    cout << endl;
    cout << b.size() << endl;
    for (int elem : b) cout << elem << ' ';
    cout << endl;
    exit(0);
}

int main() {
    int n, m;
    cin >> n >> m;
    int a[n];
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < MAX_N; i++) {
        summ[i] = 0;
        to_mask[i] = -1;
    }
    to_mask[0] = 0;
    for (int i = 1; i < (1 << n); i++) {
        int pos = 31 - __builtin_clz(i);
        summ[i] = (summ[i - (1 << pos)] + a[pos]) % m;
        if (to_mask[summ[i]] != -1) qt(n, to_mask[summ[i]], i);
        to_mask[summ[i]] = i;
    }
    cout << -1 << endl;
    return 0;
}
