#include <iostream>
#include <string>
#include <bits/stdc++.h>

#define pb push_back

using namespace std;

const int maxn = 1e3;

void init() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

string st[maxn];
int wr[maxn];
int rig[maxn];

int main() {
    init();
    int n;
    cin >> n;
    string ans;
    cin >> ans;
    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        cin >> st[i];
        for (int j = 0; j < st[i].size(); j++){
            if (st[i][j] == ans[j])
                rig[i]++;
            else
                wr[i]++;
        }
    }

    vector<pair<int,int>> result;
    for (int i = 0; i < m; i++) {
        for (int j = i + 1; j < n; j++) {
            int sovrig = 0;
            int sovwr = 0;
            for (int q = 0; q < n; q++){
                if (st[i][q] != st[j][q]) continue;
                if (st[i][q] == ans[q])
                    sovrig++;
                else
                    sovwr++;
            }
            if (sovrig > rig[i] / 2 &&
                sovrig > rig[j] / 2 &&
                sovwr > wr[i] / 2 &&
                sovwr > wr[j] / 2)
                result.pb({i, j});
        }
    }
    cout << result.size() << "\n";
    for (auto ev: result){
        cout << ev.first + 1 << ' ' << ev.second + 1 << "\n";
    }

    return 0;
}