#include <iostream>
#include <string>
#include <vector>
using namespace std;
typedef long long ll;
#define debug(x) cout << (#x) << " = " << (x) << endl;

int main() {
    int n;
    cin >> n;
    string correct_test;
    cin >> correct_test;
    int m;
    cin >> m;
    string tests[m];
    for (auto& test : tests) {
        cin >> test;
    }
    vector<pair<int,int>> matchs;
    for (int i = 0; i < m; ++i) {
        for (int j = i + 1; j < m; ++j) {
            int correct_all = 0;
            int correct = 0, wrong = 0;
            for (int t = 0; t < n; ++t) {
                if (tests[i][t] == correct_test[t]) {
                    correct_all += 1;
                    if (tests[j][t] == correct_test[t]) {
                        correct += 1;
                    }
                }
                if ((tests[i][t] != correct_test[t]) && (tests[j][t] != correct_test[t])) {
                    wrong += 1;
                }
            }
            if (correct > correct_all / 2 && wrong > (n - correct_all) / 2) {
                matchs.push_back(make_pair(i + 1, j + 1));
            }
        }
    }
    cout << matchs.size() << endl;
    for (auto i : matchs) {
        cout << i.first << ' ' << i.second << endl;
    }
}