#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int N = 25;
const int M = 4e7;

int n, m;
int a[N];
vector<int> cnt[M];

int sum(int x, int y) {
	x += y;
	if (x >= m) {
		x -= m;
	}
	return x;
}

int f(int mask) {
	int res = 0;
	for (int i = 0; i < N; ++i) {
		if (1 << i & mask) {
			res = sum(res, a[i]);
		}
	}
	return res;
}

void find_ans(int& a, int& b) {
	for (int i = 0; i < m; ++i) {
		if (cnt[i].size() >= 2) {
			a = (cnt[i][0] ^ (cnt[i][0] & cnt[i][1]));
			b = (cnt[i][1] ^ (cnt[i][0] & cnt[i][1]));
			return;
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	for (int mask = 0; mask < (1 << n); ++mask) {
		cnt[f(mask)].push_back(mask);
	}
	int a = -1, b = -1;
	find_ans(a, b);
	if (a == -1) {
		cout << "-1\n";
	}
	else {
		vector<int> ans1, ans2;
		for (int i = 0; i < n; ++i) {
			if (1 << i & a) {
				ans1.push_back(i);
			}
			if (1 << i & b) {
				ans2.push_back(i);
			}
		}
		cout << ans1.size() << '\n';
		for (int i : ans1) {
			cout << i + 1 << ' ';
		}
		cout << '\n';
		cout << ans2.size() << '\n';
		for (int i : ans2) {
			cout << i + 1 << ' ';
		}
		cout << '\n';
	}
	return 0;
}