import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class H {
    static BufferedReader bf;
    static StringTokenizer in;

    public static String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(bf.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static void main(String[] args) throws IOException {
        bf = new BufferedReader(new InputStreamReader(System.in));
        int n = nextInt();
        String answer = nextToken();
        int m = nextInt();
        String[] ans = new String[m];
        ArrayList<boolean[]> arr = new ArrayList<>();
        for (int i = 0; i < m; i++) {
            ans[i] = nextToken();
            boolean[] b = new boolean[n];
            for (int j = 0; j < n; j++) {
                if (answer.charAt(j) == ans[i].charAt(j)) {
                    b[j] = true;
                } else b[j] = false;
            }
            arr.add(b);
        }
        ArrayList<int[]> sims = new ArrayList<>();
        for (int i = 0; i < m; i++) {
            for (int j = i + 1; j < m; j++) {
                int simT = 0;
                int simF = 0;
                int t1 = 0, t2 = 0;
                int f1 = 0, f2 = 0;
                for (int k = 0; k < n; k++) {
                    if (arr.get(i)[k]) {
                        t1++;
                    } else f1++;
                    if (arr.get(j)[k]) {
                        t2++;
                    } else f2++;
                    if (ans[i].charAt(k) == ans[j].charAt(k)) {
                        if (arr.get(i)[k] && arr.get(j)[k]) {
                            simT++;
                        } else if (!arr.get(i)[k] && !arr.get(j)[k]) {
                            simF++;
                        }
                    }
                }
                if (simT > t1 / 2 && simT > t2 / 2 && simF > f1 / 2 && simF > f2 / 2) {
                    sims.add(new int[]{i + 1, j + 1});
                }
            }
        }
        System.out.println(sims.size());
        for (int i = 0; i < sims.size(); i++) {
            System.out.println(sims.get(i)[0] + " " + sims.get(i)[1]);
        }
    }
}
