from sys import setrecursionlimit
import threading
setrecursionlimit(10 ** 9)
threading.stack_size(67108864)

def main():
    answersNum = int(input())
    answersString = input()
    answers = []
    for item in answersString:
        answers.append(item)

    students = []
    for i in range(int(input())):
        students.append([])
        inp = input()
        for i, item in enumerate(inp):
            if item == answers[i]:
                students[-1].append(1)
            else:
                students[-1].append(0)

    studentsDifferences = []
    for i in range(len(students)):
        for j in range(i, len(students)):
            if i == j:
                continue
            same = 0
            for k in range(answersNum):
                if students[i][k] == students[j][k]:
                    same += 1
            studentsDifferences.append([i, j, same])

    rNum = 0
    rPairs = []
    for item in studentsDifferences:
        if item[2] > (answersNum+1) // 2:
            rNum += 1
            rPairs.append(item)
    print(rNum)
    for item in rPairs:
        print(item[0]+1, item[1]+1)


thread = threading.Thread(target=main)
thread.start()