from sys import setrecursionlimit
import threading
setrecursionlimit(10 ** 9)
threading.stack_size(67108864)

def main():
    answersNum = int(input())
    answersString = input()
    answers = []
    for item in answersString:
        answers.append(item)

    students = []
    for i in range(int(input())):
        students.append([])
        inp = input()
        for j, item in enumerate(inp):
            if item == "A":
                if answers[j] == item:
                    students[-1].append([0, 0])
                else:
                    students[-1].append([0, 1])
            elif item == "B":
                if answers[j] == item:
                    students[-1].append([1, 0])
                else:
                    students[-1].append([1, 1])
            elif item == "C":
                if answers[j] == item:
                    students[-1].append([2, 0])
                else:
                    students[-1].append([2, 1])
            else:
                if answers[j] == item:
                    students[-1].append([3, 0])
                else:
                    students[-1].append([3, 1])
        right = 0
        for item in students[-1]:
            if item[1] == 0:
                right += 1
        students[-1].append([right, answersNum-right])

    studentsDifferences = []
    for i in range(len(students)):
        for j in range(i, len(students)):
            if i == j:
                continue
            same1 = 0
            same2 = 0
            for k in range(answersNum):
                if students[i][k][0] == students[j][k][0] and students[j][k][1] == 0:
                    same1 += 1
                elif students[i][k][0] == students[j][k][0] and students[j][k][1] == 1:
                    same2 += 1
            #print(same1, same2)
            studentsDifferences.append([i, j, same1, same2])

    rNum = 0
    rPairs = []
    for item in studentsDifferences:
        if (item[2] > int(students[item[0]][answersNum][0] / 2) and item[2] > int(students[item[1]][answersNum][0] / 2)
                and
            item[3] > int(students[item[0]][answersNum][1] / 2) and item[3] > int(students[item[1]][answersNum][1] / 2)):
                rNum += 1
                rPairs.append(item)
    print(rNum)
    for item in rPairs:
        print(item[0]+1, item[1]+1)


thread = threading.Thread(target=main)
thread.start()