#include <bits/stdc++.h>
#define int long long

using namespace std;

int N = 111111;
vector<int> p(N), h(N);

int get(int x) {
    while (p[x] != x) {
        x = p[x];
    }
    return x;
}

void merge(int x, int y) {
    x = get(x);
    y = get(y);
    if (h[x] < h[y]) {
        p[y] = x;
        h[y]++;
    } else {
        p[x] = y;
        h[x]++;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < n; i++) {
        p[i] = i;
    }

    vector<vector<int>> v(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        v[a].push_back(b);
        v[b].push_back(a);
    }
    for (int i = 0; i < k; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        merge(a, b);
    }
    int q;
    cin >> q;

    for (int i = 0; i < q; i++) {
        char ch;
        cin >> ch;
        if (ch == 'T') {
            int a, b;
            cin >> a >> b;
            a--;
            b--;
            merge(a, b);
        } else if (ch == 'F') {
            int a, b;
            cin >> a >> b;
            a--;
            b--;
            v[a].push_back(b);
            v[b].push_back(a);
        } else{
            int a;
            cin >> a;
            a--;
            int cnt = 0;
            for (int j = 0; j < v[a].size(); j++) {
                if (get(a) == get(v[a][j]))
                    cnt++;
            }
            cout << cnt << '\n';
        }
    }

    return 0;
}
